=== modified file 'loggerhead.conf.example'
--- loggerhead.conf.example	2007-06-18 23:07:53 +0000
+++ loggerhead.conf.example	2007-01-14 05:40:40 +0000
@@ -12,9 +12,6 @@
 # if you want a special title on the front page, set it here:
 title = 'branches in loggerhead'
 
-# the access and debug logs can be set up to roll 'daily', 'weekly', or 'never':
-log.roll = 'weekly'
-
 # group branches by project:
 [bazaar]
 

=== modified file 'loggerhead/changecache.py'
--- loggerhead/changecache.py	2007-06-04 21:16:03 +0000
+++ loggerhead/changecache.py	2007-05-30 08:57:43 +0000
@@ -94,7 +94,7 @@
             for revid in revid_list:
                 # if the revid is in unicode, use the utf-8 encoding as the key
                 srevid = util.to_utf8(revid)
-                
+
                 if srevid in cache:
                     out.append(cache[srevid])
                 else:
@@ -102,11 +102,11 @@
                     out.append(None)
                     fetch_list.append(revid)
                     sfetch_list.append(srevid)
-            
+
             if len(fetch_list) > 0:
                 # some revisions weren't in the cache; fetch them
                 changes = self.history.get_changes_uncached(fetch_list, get_diffs)
-                if changes is None:
+                if len(changes) == 0:
                     return changes
                 for i in xrange(len(revid_list)):
                     if out[i] is None:

=== modified file 'loggerhead/controllers/__init__.py'
--- loggerhead/controllers/__init__.py	2007-06-18 23:07:53 +0000
+++ loggerhead/controllers/__init__.py	2007-05-23 10:17:08 +0000
@@ -61,7 +61,6 @@
             self._recheck_auto_folders()
     
     def _recheck_auto_folders(self):
-        log.debug('recheck...')
         if self._auto_folder is None:
             return
         auto_list = []
@@ -74,7 +73,6 @@
         auto_list.sort()
         if auto_list == self._auto_list:
             # nothing has changed; do nothing.
-            log.debug('ok')
             return
 
         # rebuild views:
@@ -109,12 +107,11 @@
     def index(self):
         for p in self._projects:
             p._recheck_auto_folders()
-        log.debug('%r' % {
+        return {
             'projects': self._projects,
             'util': util,
             'title': self._config.get('title', ''),
-        })
-        return {}
+        }
 
     def _check_rebuild(self):
         for p in self._projects:

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2007-03-14 06:10:22 +0000
+++ loggerhead/controllers/changelog_ui.py	2007-05-30 08:57:43 +0000
@@ -67,6 +67,9 @@
             entry_list = scan_list[:pagesize]
             entries = h.get_changes(entry_list)
         except:
+##             import sys
+##             print sys.exc_info()[2]
+##             import pdb; pdb.post_mortem(sys.exc_info()[2])
             self.log.exception('Exception fetching changes')
             raise InternalError('Could not fetch changes')
 

=== modified file 'loggerhead/controllers/download_ui.py'
--- loggerhead/controllers/download_ui.py	2007-01-24 19:26:27 +0000
+++ loggerhead/controllers/download_ui.py	2007-05-23 17:42:19 +0000
@@ -60,5 +60,6 @@
         self.log.info('/download %s @ %s (%d bytes)', path, h.get_revno(revid), len(content))
         response.headers['Content-Type'] = mime_type
         response.headers['Content-Length'] = len(content)
+        response.headers['Content-Disposition'] = 'attachment; filename=%s'%(filename,)
         response.body = content
         return response.body

=== modified file 'loggerhead/daemon.py'
--- loggerhead/daemon.py	2007-06-18 23:07:53 +0000
+++ loggerhead/daemon.py	2007-01-14 05:40:40 +0000
@@ -60,18 +60,3 @@
     f.write('%d\n' % (os.getpid(),))
     f.write('%s\n' % (home,))
     f.close()
-
-
-def is_running(pidfile):
-    try:
-        f = open(pidfile, 'r')
-    except IOError:
-        return False
-    pid = int(f.readline())
-    f.close()
-    try:
-        os.kill(pid, 0)
-    except OSError:
-        # no such process
-        return False
-    return True

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2007-05-29 11:19:07 +0000
+++ loggerhead/history.py	2007-05-30 08:57:43 +0000
@@ -605,7 +605,7 @@
             changes = self.get_changes_uncached(revid_list, get_diffs)
         else:
             changes = self._change_cache.get_changes(revid_list, get_diffs)
-        if changes is None:
+        if len(changes) == 0:
             return changes
         
         # some data needs to be recalculated each time, because it may
@@ -694,6 +694,8 @@
                 # i don't know why. :(
                 self.log.debug('No such revision (skipping): %s', e)
                 revid_list.remove(e.revision)
+        if not revid_list:
+            return []
         
         delta_list = self._get_deltas_for_revisions_with_trees(rev_list)
         combined_list = zip(rev_list, delta_list)

=== modified file 'loggerhead/templates/annotate.kid'
--- loggerhead/templates/annotate.kid	2007-05-21 08:06:44 +0000
+++ loggerhead/templates/annotate.kid	2007-05-23 17:49:05 +0000
@@ -15,7 +15,7 @@
 	    <div> <b>&#8594;</b> <a href="${branch.url([ '/files', revid ], **util.get_context(clear=1))}"> browse files </a> </div>
 	    <div> <b>&#8594;</b> <a href="${branch.url('/revision', **util.get_context(clear=1, start_revid=revid))}"> view revision </a> </div>
 	    <div> <b>&#8594;</b> <a href="${branch.url('/changes', **util.get_context(clear=1, start_revid=revid, file_id=file_id))}"> view changes to this file </a> </div>
-	    <div> <b>&#8594;</b> <a href="${branch.url([ '/download', revid, file_id, filename ])}"> view/download file </a> </div>
+	    <div> <b>&#8594;</b> <a href="${branch.url([ '/download', revid, file_id, filename ])}"> download file </a> </div>
 	</div>
 </h1>
 

=== modified file 'loggerhead/tests/test_simple.py'
--- loggerhead/tests/test_simple.py	2007-05-29 12:26:42 +0000
+++ loggerhead/tests/test_simple.py	2007-05-30 08:49:57 +0000
@@ -3,6 +3,7 @@
 import os
 import tempfile
 import shutil
+import logging
 
 import cherrypy
 from turbogears import testutil
@@ -18,16 +19,18 @@
     testutil.create_request('/')
     assert 'loggerhead branches' in cherrypy.response.body[0]
 
-config_template = """
-[project]
-    [[branch]]
-        branch_name = 'branch'
-        folder = '%s'
-"""
-
 
 class TestWithSimpleTree(object):
+    config_template = """
+    [project]
+        [[branch]]
+            branch_name = 'branch'
+            folder = '%(branch)s'
+    """
     def setUp(self):
+
+        logging.basicConfig(level=logging.DEBUG)
+
         self.old_bzrhome = bzrlib.osutils.set_or_unset_env('BZR_HOME', '')
         self.bzrbranch = tempfile.mkdtemp()
         branch = bzrlib.bzrdir.BzrDir.create_branch_convenience(
@@ -44,7 +47,7 @@
         self.msg = 'a very exciting commit message'
         self.revid = tree.commit(message=self.msg)
 
-        ini = config_template%self.bzrbranch
+        ini = self.config_template%dict(branch=self.bzrbranch)
 
         config = ConfigObj(ini.splitlines())
         cherrypy.root = Root(config)
@@ -70,6 +73,10 @@
         testutil.create_request('/project/branch/changes')
         assert self.msg in cherrypy.response.body[0]
 
+    def test_changes_search(self):
+        testutil.create_request('/project/branch/changes?q=foo')
+        assert 'Sorry, no results found for your search.' in cherrypy.response.body[0]
+
     def test_annotate(self):
         testutil.create_request('/project/branch/annotate?'
                                 + 'file_id='+self.fileid)
@@ -80,3 +87,12 @@
         testutil.create_request('/project/branch/files')
         assert 'myfilename' in cherrypy.response.body[0]
 
+class TestWithSimpleTreeAndCache(TestWithSimpleTree):
+    config_template = """
+    testing = True
+    [project]
+        [[branch]]
+            branch_name = 'branch'
+            folder = '%(branch)s'
+            cachepath = '%(branch)s/cache'
+    """

=== modified file 'start-loggerhead.py'
--- start-loggerhead.py	2007-06-18 23:07:53 +0000
+++ start-loggerhead.py	2007-05-23 10:17:08 +0000
@@ -5,28 +5,15 @@
 
 import logging
 import os
-import sys
-from optparse import OptionParser
 
 import turbogears
 import cherrypy
 cherrypy.lowercase_api = True
 
-from loggerhead import daemon, release
-
-
-def make_handler(config, filename):
-    roll = config.get('log.roll', 'never')
-    if roll == 'daily':
-        h = logging.handlers.TimedRotatingFileHandler(filename, 'midnight', 0, 100)
-    elif roll == 'weekly':
-        h = logging.handlers.TimedRotatingFileHandler(filename, 'W0', 0, 100)
-    else:
-        h = logging.handlers.FileHandler(filename)
-    return h
-
-        
-def setup_logging(home, config, foreground):
+import sys
+
+
+def setup_logging(home, foreground):
     # i hate that stupid logging config format, so just set up logging here.
 
     log_folder = os.path.join(home, 'logs')
@@ -35,7 +22,7 @@
     
     f = logging.Formatter('%(levelname)-.3s [%(asctime)s.%(msecs)03d] %(name)s: %(message)s',
                           '%Y%m%d-%H:%M:%S')
-    debug_log = make_handler(config, os.path.join(log_folder, 'debug.log'))
+    debug_log = logging.FileHandler(os.path.join(log_folder, 'debug.log'))
     debug_log.setLevel(logging.DEBUG)
     debug_log.setFormatter(f)
     if foreground:
@@ -44,7 +31,7 @@
         stdout_log.setFormatter(f)
     f = logging.Formatter('[%(asctime)s.%(msecs)03d] %(message)s',
                           '%Y%m%d-%H:%M:%S')
-    access_log = make_handler(config, os.path.join(log_folder, 'access.log'))
+    access_log = logging.FileHandler(os.path.join(log_folder, 'access.log'))
     access_log.setLevel(logging.INFO)
     access_log.setFormatter(f)
     
@@ -57,73 +44,61 @@
     
 
 
-def main():
-    parser = OptionParser(usage='usage: %prog [options]', version='%prog ' + release.version)
-    parser.add_option('-f', '--foreground', action='store_true', dest='foreground', default=False,
-                      help="run in the foreground; don't daemonize")
-    parser.add_option('-C', '--check', action='store_true', dest='check', default=False,
-                      help="only start if not already running (useful for cron jobs)")
-    options, args = parser.parse_args()
-    if len(args) > 0:
-        parser.error('No filename arguments are used, only options.')
-        
-        
-    home = os.path.realpath(os.path.dirname(__file__))
-    pidfile = os.path.join(home, 'loggerhead.pid')
-    
-    if options.check:
-        if daemon.is_running(pidfile):
-            sys.exit(0)
-        sys.stderr.write('Did not find okulo running in %r; restarting...\n' % (pidfile,))
-    
-    # read loggerhead config
-    
-    from configobj import ConfigObj
-    config = ConfigObj(os.path.join(home, 'loggerhead.conf'), encoding='utf-8')
-    extra_path = config.get('bzrpath', None)
-    if extra_path:
-        sys.path.insert(0, extra_path)
-    
-    turbogears.update_config(configfile="dev.cfg", modulename="loggerhead.config")
-    
-    potential_overrides = [ ('server.socket_port', int), ('server.webpath', str), ('server.thread_pool', int) ]
-    for key, keytype in potential_overrides:
-        value = config.get(key, None)
-        if value is not None:
-            value = keytype(value)
-            turbogears.config.update({ key: value })
-    
-    if not options.foreground:
-        sys.stderr.write('\n')
-        sys.stderr.write('Launching loggerhead into the background.\n')
-        sys.stderr.write('PID file: %s\n' % (pidfile,))
-        sys.stderr.write('\n')
-    
-        daemon.daemonize(pidfile, home)
-
-    setup_logging(home, config, foreground=options.foreground)
-        
-    log = logging.getLogger('loggerhead')
-    log.info('Starting up...')
-    
-    from loggerhead.controllers import Root
-    
-    Root = Root(config)
-    
-    # re-index every 6 hours
-    
-    index_freq = config.get('cache_rebuild_frequency', 6 * 3600)
-    turbogears.scheduler.add_interval_task(initialdelay=1, interval=index_freq, action=Root._check_rebuild)
-    
+foreground = False
+if len(sys.argv) > 1:
+    if sys.argv[1] == '-f':
+        foreground = True
+
+home = os.path.realpath(os.path.dirname(__file__))
+pidfile = os.path.join(home, 'loggerhead.pid')
+
+# read loggerhead config
+
+from configobj import ConfigObj
+config = ConfigObj(os.path.join(home, 'loggerhead.conf'), encoding='utf-8')
+extra_path = config.get('bzrpath', None)
+if extra_path:
+    sys.path.insert(0, extra_path)
+
+turbogears.update_config(configfile="dev.cfg", modulename="loggerhead.config")
+
+potential_overrides = [ ('server.socket_port', int), ('server.webpath', str), ('server.thread_pool', int) ]
+for key, keytype in potential_overrides:
+    value = config.get(key, None)
+    if value is not None:
+        value = keytype(value)
+        turbogears.config.update({ key: value })
+
+if not foreground:
+    sys.stderr.write('\n')
+    sys.stderr.write('Launching loggerhead into the background.\n')
+    sys.stderr.write('PID file: %s\n' % (pidfile,))
+    sys.stderr.write('\n')
+
+    from loggerhead.daemon import daemonize
+    daemonize(pidfile, home)
+
+setup_logging(home, foreground=foreground)
+    
+log = logging.getLogger('loggerhead')
+log.info('Starting up...')
+
+from loggerhead.controllers import Root
+
+Root = Root(config)
+
+# re-index every 6 hours
+
+index_freq = config.get('cache_rebuild_frequency', 6 * 3600)
+turbogears.scheduler.add_interval_task(initialdelay=1, interval=index_freq, action=Root._check_rebuild)
+
+try:
+    turbogears.start_server(Root)
+finally:
+    log.info('Shutdown.')
     try:
-        turbogears.start_server(Root)
-    finally:
-        log.info('Shutdown.')
-        try:
-            os.remove(pidfile)
-        except OSError:
-            pass
-
-
-if __name__ == '__main__':
-    main()
+        os.remove(pidfile)
+    except OSError:
+        pass
+
+

